diff --git a/SHADE_Engine/src/Math/Transform/SHTransform.cpp b/SHADE_Engine/src/Math/Transform/SHTransform.cpp
index f51d73ec..ef7c5fda 100644
--- a/SHADE_Engine/src/Math/Transform/SHTransform.cpp
+++ b/SHADE_Engine/src/Math/Transform/SHTransform.cpp
@@ -26,15 +26,15 @@ namespace SHADE
   /*-----------------------------------------------------------------------------------*/
 
   SHTransform::SHTransform() noexcept
-  : position  { SHVec3::Zero }
-  , rotation  { SHVec3::Zero }
-  , scale     { SHVec3::One  }
+  : position    { SHVec3::Zero }
+  , orientation { SHQuaternion::Identity }
+  , scale       { SHVec3::One  }
   {}
 
   SHTransform::SHTransform(const SHVec3& pos, const SHVec3& rot, const SHVec3& scl) noexcept
-  : position  { pos }
-  , rotation  { rot }
-  , scale     { scl }
+  : position    { pos }
+  , orientation { SHQuaternion::FromEuler(rot) }
+  , scale       { scl }
   {}
 
   /*-----------------------------------------------------------------------------------*/
@@ -43,12 +43,12 @@ namespace SHADE
 
   bool SHTransform::operator==(const SHTransform& rhs) const noexcept
   {
-    return !(position != rhs.position || rotation != rhs.rotation || scale != rhs.scale);
+    return !(position != rhs.position || orientation != rhs.orientation || scale != rhs.scale);
   }
 
   bool SHTransform::operator!=(const SHTransform& rhs) const noexcept
   {
-    return (position != rhs.position || rotation != rhs.rotation || scale != rhs.scale);
+    return (position != rhs.position || orientation != rhs.orientation || scale != rhs.scale);
   }
 
   /*-----------------------------------------------------------------------------------*/
@@ -59,7 +59,7 @@ namespace SHADE
   {
     
     const SHMatrix T = SHMatrix::Translate(position);
-    const SHMatrix R = SHMatrix::Rotate(rotation);
+    const SHMatrix R = SHMatrix::Rotate(orientation);
     const SHMatrix S = SHMatrix::Scale(scale);
 
     trs = S * R * T;
diff --git a/SHADE_Engine/src/Math/Transform/SHTransform.h b/SHADE_Engine/src/Math/Transform/SHTransform.h
index c1a0e565..2e7d236c 100644
--- a/SHADE_Engine/src/Math/Transform/SHTransform.h
+++ b/SHADE_Engine/src/Math/Transform/SHTransform.h
@@ -12,8 +12,8 @@
 
 // Project Headers
 #include "SH_API.h"
-#include "Math/Vector/SHVec2.h"
 #include "Math/Vector/SHVec3.h"
+#include "Math/SHQuaternion.h"
 #include "Math/SHMatrix.h"
 
 namespace SHADE
@@ -31,22 +31,23 @@ namespace SHADE
 
     static const SHTransform Identity;
 
-    SHVec3    position;
-    SHVec3    rotation;
-    SHVec3    scale;
+    SHVec3        position;
+    SHQuaternion  orientation;
+    SHVec3        scale;
 
-    SHMatrix  trs;
+    SHMatrix      trs;
 
     /*---------------------------------------------------------------------------------*/
     /* Constructors & Destructor                                                       */
     /*---------------------------------------------------------------------------------*/
     
-    SHTransform             (const SHTransform&)  = default;
-    SHTransform             (SHTransform&&)       = default;
-    ~SHTransform            ()                    = default;
+    SHTransform   (const SHTransform&)  = default;
+    SHTransform   (SHTransform&&)       = default;
+    ~SHTransform  ()                    = default;
 
-    SHTransform             ()                                                        noexcept;
-    SHTransform             (const SHVec3& pos, const SHVec3& rot, const SHVec3& scl) noexcept;
+    SHTransform   ()                                                                noexcept;
+    SHTransform   (const SHVec3& pos, const SHVec3& rot, const SHVec3& scl)         noexcept;
+    SHTransform   (const SHVec3& pos, const SHQuaternion& quat, const SHVec3& scl)  noexcept;
 
     /*---------------------------------------------------------------------------------*/
     /* Operator Overloads                                                              */
@@ -63,7 +64,6 @@ namespace SHADE
     /*---------------------------------------------------------------------------------*/
 
     const SHMatrix& ComputeTRS();
-
   };
 
 } // namespace SHADE
\ No newline at end of file
diff --git a/SHADE_Engine/src/Math/Transform/SHTransformComponent.cpp b/SHADE_Engine/src/Math/Transform/SHTransformComponent.cpp
index 949cfa67..e56cbc8d 100644
--- a/SHADE_Engine/src/Math/Transform/SHTransformComponent.cpp
+++ b/SHADE_Engine/src/Math/Transform/SHTransformComponent.cpp
@@ -12,6 +12,8 @@
 
 // Primary Header
 #include "SHTransformComponent.h"
+// Project Headers
+#include "Math/SHMathHelpers.h"
 
 namespace SHADE
 {
@@ -40,7 +42,12 @@ namespace SHADE
 
   const SHVec3& SHTransformComponent::GetLocalRotation() const noexcept
   {
-    return local.rotation;
+    return localRotation;
+  }
+
+  const SHQuaternion& SHTransformComponent::GetLocalOrientation() const noexcept
+  {
+    return local.orientation;
   }
 
   const SHVec3& SHTransformComponent::GetLocalScale() const noexcept
@@ -55,7 +62,12 @@ namespace SHADE
 
   const SHVec3& SHTransformComponent::GetWorldRotation() const noexcept
   {
-    return world.rotation;
+    return worldRotation;
+  }
+
+  const SHQuaternion& SHTransformComponent::GetWorldOrientation() const noexcept
+  {
+    return world.orientation;
   }
 
   const SHVec3& SHTransformComponent::GetWorldScale() const noexcept
@@ -91,16 +103,28 @@ namespace SHADE
   void SHTransformComponent::SetLocalRotation(const SHVec3& newLocalRotation) noexcept
   {
     dirty = true;
-    local.rotation = newLocalRotation;
+
+    localRotation = newLocalRotation;
+    updateQueue.push({ UpdateCommandType::LOCAL_ROTATION, newLocalRotation });
   }
 
   void SHTransformComponent::SetLocalRotation(float pitch, float yaw, float roll) noexcept
   {
     dirty = true;
 
-    local.rotation.x = pitch;
-    local.rotation.y = yaw;
-    local.rotation.z = roll;
+    localRotation.x = pitch;
+    localRotation.y = yaw;
+    localRotation.z = roll;
+
+    updateQueue.push({ UpdateCommandType::LOCAL_ROTATION, SHVec3{pitch, yaw, roll} });
+  }
+
+  void SHTransformComponent::SetLocalOrientation(const SHQuaternion& newLocalOrientation) noexcept
+  {
+    dirty = true;
+
+    local.orientation = newLocalOrientation;
+    updateQueue.push({ UpdateCommandType::LOCAL_ORIENTATION, newLocalOrientation });
   }
 
   void SHTransformComponent::SetLocalScale(const SHVec3& newLocalScale) noexcept
@@ -121,7 +145,7 @@ namespace SHADE
   {
     dirty = true;
 
-    world.rotation = newWorldRotation;
+    worldRotation = newWorldRotation;
     updateQueue.push({ UpdateCommandType::WORLD_ROTATION, newWorldRotation });
   }
 
@@ -129,13 +153,21 @@ namespace SHADE
   {
     dirty = true;
 
-    world.rotation.x = pitch;
-    world.rotation.y = yaw;
-    world.rotation.z = roll;
+    worldRotation.x = pitch;
+    worldRotation.y = yaw;
+    worldRotation.z = roll;
 
     updateQueue.push({ UpdateCommandType::WORLD_ROTATION, SHVec3{ pitch, yaw, roll} });
   }
 
+  void SHTransformComponent::SetWorldOrientation(const SHQuaternion& newWorldOrientation) noexcept
+  {
+    dirty = true;
+
+    world.orientation = newWorldOrientation;
+    updateQueue.push({ UpdateCommandType::WORLD_ORIENTATION, newWorldOrientation });
+  }
+
   void SHTransformComponent::SetWorldScale(const SHVec3& newWorldScale) noexcept
   {
     dirty = true;
@@ -153,6 +185,6 @@ RTTR_REGISTRATION
 
   registration::class_<SHTransformComponent>("Transform Component")
     .property("Translate" , &SHTransformComponent::GetLocalPosition , &SHTransformComponent::SetLocalPosition                                       )
-    .property("Rotate"    , &SHTransformComponent::GetLocalRotation , select_overload<void(SHVec3 const&)>(&SHTransformComponent::SetLocalRotation) )
+    .property("Rotate"    , &SHTransformComponent::GetLocalRotation , select_overload<void(const SHVec3&)>(&SHTransformComponent::SetLocalRotation) )
     .property("Scale"     , &SHTransformComponent::GetLocalScale    , &SHTransformComponent::SetLocalScale                                          );
 }
\ No newline at end of file
diff --git a/SHADE_Engine/src/Math/Transform/SHTransformComponent.h b/SHADE_Engine/src/Math/Transform/SHTransformComponent.h
index ad355694..2fe67bdd 100644
--- a/SHADE_Engine/src/Math/Transform/SHTransformComponent.h
+++ b/SHADE_Engine/src/Math/Transform/SHTransformComponent.h
@@ -56,42 +56,52 @@ namespace SHADE
     /* Getter Functions                                                                */
     /*---------------------------------------------------------------------------------*/
 
-    [[nodiscard]] bool                HasChanged        ()  const noexcept;
+    [[nodiscard]] bool                HasChanged          ()  const noexcept;
 
-    [[nodiscard]] const SHVec3&       GetLocalPosition  ()  const noexcept;
-    [[nodiscard]] const SHVec3&       GetLocalRotation  ()  const noexcept;
-    [[nodiscard]] const SHVec3&       GetLocalScale     ()  const noexcept;
-    [[nodiscard]] const SHVec3&       GetWorldPosition  ()  const noexcept;
-    [[nodiscard]] const SHVec3&       GetWorldRotation  ()  const noexcept;
-    [[nodiscard]] const SHVec3&       GetWorldScale     ()  const noexcept;
+    [[nodiscard]] const SHVec3&       GetLocalPosition    ()  const noexcept;
+    [[nodiscard]] const SHVec3&       GetLocalRotation    ()  const noexcept;
+    [[nodiscard]] const SHQuaternion& GetLocalOrientation ()  const noexcept;
+    [[nodiscard]] const SHVec3&       GetLocalScale       ()  const noexcept;
+    [[nodiscard]] const SHVec3&       GetWorldPosition    ()  const noexcept;
+    [[nodiscard]] const SHVec3&       GetWorldRotation    ()  const noexcept;
+    [[nodiscard]] const SHQuaternion& GetWorldOrientation ()  const noexcept;
+    [[nodiscard]] const SHVec3&       GetWorldScale       ()  const noexcept;
 
-    [[nodiscard]] const SHMatrix&     GetLocalToWorld   ()  const noexcept;
-    [[nodiscard]] SHMatrix            GetWorldToLocal   ()  const noexcept;
+    [[nodiscard]] const SHMatrix&     GetLocalToWorld     ()  const noexcept;
+    [[nodiscard]] SHMatrix            GetWorldToLocal     ()  const noexcept;
 
-    [[nodiscard]] const SHMatrix&     GetTRS            ()  const noexcept;
+    [[nodiscard]] const SHMatrix&     GetTRS              ()  const noexcept;
 
     /*---------------------------------------------------------------------------------*/
     /* Setter Functions                                                                */
     /*---------------------------------------------------------------------------------*/
 
-    void  SetLocalPosition  (const SHVec3& newLocalPosition)      noexcept;
-    void  SetLocalRotation  (const SHVec3& newLocalRotation)      noexcept;
-    void  SetLocalRotation  (float pitch, float yaw, float roll)  noexcept;
-    void  SetLocalScale     (const SHVec3& newLocalScale)         noexcept;
-    void  SetWorldPosition  (const SHVec3& newWorldPosition)      noexcept;
-    void  SetWorldRotation  (const SHVec3& newWorldRotation)      noexcept;
-    void  SetWorldRotation  (float pitch, float yaw, float roll)  noexcept;
-    void  SetWorldScale     (const SHVec3& newWorldScale)         noexcept;
+    void  SetLocalPosition    (const SHVec3& newLocalPosition)          noexcept;
+    void  SetLocalRotation    (const SHVec3& newLocalRotation)          noexcept;
+    void  SetLocalRotation    (float pitch, float yaw, float roll)      noexcept;
+    void  SetLocalOrientation (const SHQuaternion& newLocalOrientation) noexcept;
+    void  SetLocalScale       (const SHVec3& newLocalScale)             noexcept;
+    void  SetWorldPosition    (const SHVec3& newWorldPosition)          noexcept;
+    void  SetWorldRotation    (const SHVec3& newWorldRotation)          noexcept;
+    void  SetWorldRotation    (float pitch, float yaw, float roll)      noexcept;
+    void  SetWorldOrientation (const SHQuaternion& newWorldOrientation) noexcept;
+    void  SetWorldScale       (const SHVec3& newWorldScale)             noexcept;
 
   private:
     /*---------------------------------------------------------------------------------*/
     /* Type Definitions                                                                */
     /*---------------------------------------------------------------------------------*/
 
+    // Differentiate between rotation and orientation for setters
+    // Setting a quaternion directly is different from using euler angle rotations.
+
     enum class UpdateCommandType
     {
-      WORLD_POSITION
+      LOCAL_ROTATION
+    , LOCAL_ORIENTATION
+    , WORLD_POSITION
     , WORLD_ROTATION
+    , WORLD_ORIENTATION
     , WORLD_SCALE
     };
 
@@ -103,7 +113,7 @@ namespace SHADE
       /*-------------------------------------------------------------------------------*/
 
       UpdateCommandType type;
-      SHVec3            data;
+      SHVec4            data;
     };
 
     using UpdateQueue = std::queue<UpdateCommand>;
@@ -114,6 +124,12 @@ namespace SHADE
 
     bool        dirty;
 
+    // We store euler angle rotations separately to interface with transform quaternions.
+    // Reading quaternions are unreliable.
+
+    SHVec3      localRotation;    // Stored in Radians
+    SHVec3      worldRotation;    // Stored in Radians
+
     SHTransform local;    // Local TRS holds Local To World Transform
     SHTransform world;
 
diff --git a/SHADE_Engine/src/Math/Transform/SHTransformSystem.cpp b/SHADE_Engine/src/Math/Transform/SHTransformSystem.cpp
index 6b05e323..5a540cd4 100644
--- a/SHADE_Engine/src/Math/Transform/SHTransformSystem.cpp
+++ b/SHADE_Engine/src/Math/Transform/SHTransformSystem.cpp
@@ -17,7 +17,8 @@
 #include "Scene/SHSceneManager.h"
 #include "ECS_Base/Managers/SHComponentManager.h"
 #include "ECS_Base/Managers/SHEntityManager.h"
-#include "Tools/SHException.h"
+#include "ECS_Base/Managers/SHSystemManager.h"
+#include "Math/SHMathHelpers.h"
 
 namespace SHADE
 {
@@ -29,8 +30,12 @@ namespace SHADE
   /* Constructors & Destructor Definitions                                             */
   /*-----------------------------------------------------------------------------------*/
 
-  SHTransformSystem::TransformUpdateRoutine::TransformUpdateRoutine()
-  : SHSystemRoutine { "Transform Update", true }
+  SHTransformSystem::TransformPostLogicUpdate::TransformPostLogicUpdate()
+  : SHSystemRoutine { "Transform Post-Logic Update", true }
+  {}
+
+  SHTransformSystem::TransformPostPhysicsUpdate::TransformPostPhysicsUpdate()
+  : SHSystemRoutine { "Transform Post-Physics Update", false }
   {}
 
 
@@ -38,16 +43,27 @@ namespace SHADE
   /* Public Function Member Definitions                                                */
   /*-----------------------------------------------------------------------------------*/
 
-  void SHTransformSystem::TransformUpdateRoutine::Execute(double) noexcept
+  void SHTransformSystem::TransformPostLogicUpdate::Execute(double) noexcept
   {
     // Get the current scene graph to traverse and update
     const auto& SCENE_GRAPH = SHSceneManager::GetCurrentSceneGraph();
-    UpdateEntity(SCENE_GRAPH.GetRoot());
+
+    // TODO(Diren): Consider how to clear dirty in pause / stop mode and update physics, but do not clear in play mode.
+    UpdateEntity(SCENE_GRAPH.GetRoot(), false);
+  }
+
+  void SHTransformSystem::TransformPostPhysicsUpdate::Execute(double) noexcept
+  {
+    // Get the current scene graph to traverse and update
+    const auto& SCENE_GRAPH = SHSceneManager::GetCurrentSceneGraph();
+    UpdateEntity(SCENE_GRAPH.GetRoot(), true);
   }
 
   void SHTransformSystem::Init()
   {
-
+    std::shared_ptr thisReceiver { std::make_shared<SHEventReceiverSpec<SHTransformSystem>>(this, &SHTransformSystem::ChangeParent) };
+    ReceiverPtr receiver = std::dynamic_pointer_cast<SHEventReceiver>(thisReceiver);
+    SHEventManager::SubscribeTo(SH_SCENEGRAPH_CHANGE_PARENT_EVENT, receiver);
   }
 
   void SHTransformSystem::Exit()
@@ -59,7 +75,97 @@ namespace SHADE
   /* Private Function Member Definitions                                               */
   /*-----------------------------------------------------------------------------------*/
 
-  void SHTransformSystem::UpdateEntity(const SHSceneNode* node)
+  SHEventHandle SHTransformSystem::ChangeParent(SHEventPtr changeParentEvent)
+  {
+    const auto& eventData = reinterpret_cast<const SHEventSpec<SHSceneGraphChangeParentEvent>*>(changeParentEvent.get());
+
+    auto* node = eventData->data->node;
+    auto* tf = SHComponentManager::GetComponent_s<SHTransformComponent>(node->GetEntityID());
+
+    // Recompute local transform and store localToWorld Matrix
+    SHMatrix localToWorld = SHMatrix::Identity; 
+    SHMatrix worldToLocal = SHMatrix::Identity;
+
+    auto* newParent = eventData->data->newParent;
+    const auto* PARENT_TF = SHComponentManager::GetComponent_s<SHTransformComponent>(newParent->GetEntityID());
+    if (PARENT_TF != nullptr) // Not the root
+    {
+      localToWorld = PARENT_TF->GetTRS();
+      worldToLocal = SHMatrix::Inverse(localToWorld);
+    }
+
+    // Maintain World Transform and recompute Local Transform
+
+    // Compute Local Position
+    tf->local.position = SHVec3::Transform(tf->world.position, worldToLocal);
+
+          
+    tf->localRotation = tf->worldRotation;
+    tf->local.scale   = tf->world.scale;
+
+    if (PARENT_TF != nullptr)
+    {
+      // Compute Local Rotation
+      tf->localRotation -= PARENT_TF->GetLocalRotation();
+
+      // Compute Local Scale
+      tf->local.scale /= PARENT_TF->GetLocalScale();
+    }
+
+    tf->local.trs = localToWorld;
+
+    // Propagate maintaining world transform down the branch
+    UpdateChildrenLocalTransforms(node);
+    return eventData->handle;
+  }
+
+  void SHTransformSystem::UpdateChildrenLocalTransforms(SHSceneNode* node)
+  {
+    // Structure is similar to update entity, albeit without a queue to do being a forced update
+    for (const auto* child : node->GetChildren())
+    {
+      if (auto* childTransform = SHComponentManager::GetComponent_s<SHTransformComponent>(child->GetEntityID()); childTransform)
+      {
+        const bool IS_NODE_ACTIVE = child->IsActive();
+        if (IS_NODE_ACTIVE && childTransform->isActive)
+        {
+          // Recompute local transform and store localToWorld Matrix
+          SHMatrix localToWorld = SHMatrix::Identity; 
+          SHMatrix worldToLocal = SHMatrix::Identity;
+
+          const auto* parent = SHComponentManager::GetComponent_s<SHTransformComponent>(node->GetEntityID());
+
+          if (parent != nullptr) // Not the root
+          {
+            localToWorld = parent->GetTRS();
+            worldToLocal = SHMatrix::Inverse(localToWorld);
+          }
+
+          // Maintain World Transform and recompute Local Transform
+
+          // Compute Local Position
+          childTransform->local.position = SHVec3::Transform(childTransform->world.position, worldToLocal);
+
+          
+          childTransform->localRotation = childTransform->worldRotation;
+          childTransform->local.scale   = childTransform->world.scale;
+
+          if (parent)
+          {
+            // Compute Local Rotation
+            childTransform->localRotation -= parent->GetLocalRotation();
+
+            // Compute Local Scale
+            childTransform->local.scale /= parent->GetLocalScale();
+          }
+
+          childTransform->local.trs = localToWorld;
+        }
+      }
+    }
+  }
+
+  void SHTransformSystem::UpdateEntity(const SHSceneNode* node, bool clearDirtyFlag)
   {
     const auto* NODE_TRANSFORM = SHComponentManager::GetComponent_s<SHTransformComponent>(node->GetEntityID());
     const bool HAS_PARENT_CHANGED = NODE_TRANSFORM && NODE_TRANSFORM->dirty;
@@ -74,14 +180,17 @@ namespace SHADE
         if (IS_NODE_ACTIVE && childTransform->isActive)
         {
           if (childTransform->dirty || HAS_PARENT_CHANGED)
+          {
             UpdateTransform(*childTransform, NODE_TRANSFORM);
+            childTransform->dirty = true;
+          }
         }
       }
 
-      UpdateEntity(child);
+      UpdateEntity(child, clearDirtyFlag);
 
       // Clear dirty flag after all children are updated
-      if (childTransform)
+      if (childTransform && clearDirtyFlag)
         childTransform->dirty = false;
     }
   }
@@ -91,6 +200,8 @@ namespace SHADE
     SHMatrix localToWorld = SHMatrix::Identity;
     SHMatrix worldToLocal = SHMatrix::Identity;
 
+    bool convertRotation = true;
+
     if (parent)
     {
       localToWorld = parent->GetTRS();
@@ -103,22 +214,44 @@ namespace SHADE
 
       switch (UPDATE_COMMAND.type)
       {
+        case SHTransformComponent::UpdateCommandType::LOCAL_ROTATION:
+        {
+          convertRotation = true;
+          break;
+        }
+        case SHTransformComponent::UpdateCommandType::LOCAL_ORIENTATION:
+        {
+          convertRotation = false;
+          break;
+        }
         case SHTransformComponent::UpdateCommandType::WORLD_POSITION:
         {
-          tf.local.position = SHVec3::Transform(UPDATE_COMMAND.data, worldToLocal);
+          tf.local.position = SHVec3::Transform(UPDATE_COMMAND.data.ToVec3(), worldToLocal);
           break;
         }
         case SHTransformComponent::UpdateCommandType::WORLD_ROTATION:
         {
-          tf.local.rotation = tf.world.rotation;
+          tf.localRotation = UPDATE_COMMAND.data.ToVec3();
           if (parent)
-            tf.local.rotation -= parent->GetLocalRotation();
+            tf.localRotation -= parent->GetLocalRotation();
+
+          convertRotation = true;
+
+          break;
+        }
+        case SHTransformComponent::UpdateCommandType::WORLD_ORIENTATION:
+        {
+          tf.local.orientation = UPDATE_COMMAND.data;
+          if (parent)
+            tf.local.orientation /= parent->GetLocalOrientation();
+
+          convertRotation = false;
 
           break;
         }
         case SHTransformComponent::UpdateCommandType::WORLD_SCALE:
         {
-          tf.local.scale = tf.world.scale;
+          tf.local.scale = UPDATE_COMMAND.data.ToVec3();
           if (parent)
             tf.local.scale /= parent->GetLocalScale();
 
@@ -133,15 +266,38 @@ namespace SHADE
 
     tf.local.trs = localToWorld;
 
+    // Compute world transforms
     tf.world.position = SHVec3::Transform(tf.local.position, localToWorld);
-    tf.world.rotation = tf.local.rotation + (parent ? parent->GetLocalRotation() : SHVec3::Zero);
     tf.world.scale    = tf.local.scale * (parent ? parent->GetLocalScale() : SHVec3::One);
 
-    tf.world.ComputeTRS();
+    
 
-    // Transpose TRS to column major
-    //tf.local.trs.Transpose();
-    //tf.world.trs.Transpose();
+    if (convertRotation)
+    {
+      tf.worldRotation  = tf.localRotation + (parent ? parent->GetLocalRotation() : SHVec3::Zero);
+
+      // Set the orientation
+      // Wrap rotations between -360 and 360 and convert to radians
+      SHVec3 worldRotRad, localRotRad;
+      for (size_t i = 0; i < SHVec3::SIZE; ++i)
+      {
+        worldRotRad[i] = SHMath::Wrap(tf.worldRotation[i], -SHMath::TWO_PI, SHMath::TWO_PI);
+        localRotRad[i] = SHMath::Wrap(tf.localRotation[i], -SHMath::TWO_PI, SHMath::TWO_PI);
+      }
+
+      tf.world.orientation = SHQuaternion::FromEuler(worldRotRad);
+      tf.local.orientation = SHQuaternion::FromEuler(localRotRad);
+    }
+    else
+    {
+      tf.world.orientation = (parent ? parent->GetLocalOrientation() : SHQuaternion::Identity) * tf.local.orientation;
+
+      // Set the euler angle rotations
+      tf.worldRotation = tf.world.orientation.ToEuler();
+      tf.localRotation = tf.local.orientation.ToEuler();
+    }
+
+    tf.world.ComputeTRS();
   }
 
 } // namespace SHADE
\ No newline at end of file
diff --git a/SHADE_Engine/src/Math/Transform/SHTransformSystem.h b/SHADE_Engine/src/Math/Transform/SHTransformSystem.h
index 02c3b6c6..e63969ce 100644
--- a/SHADE_Engine/src/Math/Transform/SHTransformSystem.h
+++ b/SHADE_Engine/src/Math/Transform/SHTransformSystem.h
@@ -45,25 +45,52 @@ namespace SHADE
     /* System Routines                                                                 */
     /*---------------------------------------------------------------------------------*/
 
-    class SH_API TransformUpdateRoutine final: public SHSystemRoutine
+    class SH_API TransformPostLogicUpdate final: public SHSystemRoutine
     {
     public:
       /*-------------------------------------------------------------------------------*/
       /* Constructors & Destructor                                                     */
       /*-------------------------------------------------------------------------------*/
 
-      TransformUpdateRoutine   ();
-      ~TransformUpdateRoutine  () = default;
+      TransformPostLogicUpdate   ();
+      ~TransformPostLogicUpdate  () = default;
 
-      TransformUpdateRoutine   (const TransformUpdateRoutine&)  = delete;
-      TransformUpdateRoutine   (TransformUpdateRoutine&&)       = delete;
+      TransformPostLogicUpdate   (const TransformPostLogicUpdate&)  = delete;
+      TransformPostLogicUpdate   (TransformPostLogicUpdate&&)       = delete;
 
       /*-------------------------------------------------------------------------------*/
       /* Operator Overloads                                                            */
       /*-------------------------------------------------------------------------------*/
 
-      TransformUpdateRoutine& operator= (const TransformUpdateRoutine&) = delete;
-      TransformUpdateRoutine& operator= (TransformUpdateRoutine&&)      = delete;
+      TransformPostLogicUpdate& operator= (const TransformPostLogicUpdate&) = delete;
+      TransformPostLogicUpdate& operator= (TransformPostLogicUpdate&&)      = delete;
+
+      /*-------------------------------------------------------------------------------*/
+      /* Function Members                                                              */
+      /*-------------------------------------------------------------------------------*/
+
+      void Execute(double dt) noexcept override;
+    };
+
+    class SH_API TransformPostPhysicsUpdate final: public SHSystemRoutine
+    {
+    public:
+      /*-------------------------------------------------------------------------------*/
+      /* Constructors & Destructor                                                     */
+      /*-------------------------------------------------------------------------------*/
+
+      TransformPostPhysicsUpdate   ();
+      ~TransformPostPhysicsUpdate  () = default;
+
+      TransformPostPhysicsUpdate   (const TransformPostPhysicsUpdate&)  = delete;
+      TransformPostPhysicsUpdate   (TransformPostPhysicsUpdate&&)       = delete;
+
+      /*-------------------------------------------------------------------------------*/
+      /* Operator Overloads                                                            */
+      /*-------------------------------------------------------------------------------*/
+
+      TransformPostPhysicsUpdate& operator= (const TransformPostPhysicsUpdate&) = delete;
+      TransformPostPhysicsUpdate& operator= (TransformPostPhysicsUpdate&&)      = delete;
 
       /*-------------------------------------------------------------------------------*/
       /* Function Members                                                              */
@@ -84,8 +111,11 @@ namespace SHADE
     /* Function Members                                                                */
     /*---------------------------------------------------------------------------------*/
 
-    static void UpdateEntity   (const SHSceneNode* node);
-    static void UpdateTransform(SHTransformComponent& tf, const SHTransformComponent* parent = nullptr);
+    SHEventHandle ChangeParent                  (SHEventPtr changeParentEvent);
+    static void   UpdateChildrenLocalTransforms (SHSceneNode* node);
+
+    static void   UpdateEntity                  (const SHSceneNode* node, bool clearDirtyFlag);
+    static void   UpdateTransform               (SHTransformComponent& tf, const SHTransformComponent* parent = nullptr);
   };
 
 
diff --git a/SHADE_Engine/src/Math/Vector/SHVec4.cpp b/SHADE_Engine/src/Math/Vector/SHVec4.cpp
index bcf2ef97..9857818a 100644
--- a/SHADE_Engine/src/Math/Vector/SHVec4.cpp
+++ b/SHADE_Engine/src/Math/Vector/SHVec4.cpp
@@ -38,6 +38,10 @@ namespace SHADE
   : XMFLOAT4( 0.0f, 0.0f, 0.0f, 0.0f )
   {}
 
+  SHVec4::SHVec4(const SHVec3& vec3) noexcept
+  : XMFLOAT4( vec3.x, vec3.y, vec3.z, 1.0f )
+  {}
+
   SHVec4::SHVec4(const XMFLOAT4& xmfloat4) noexcept
   : XMFLOAT4( xmfloat4.x, xmfloat4.y, xmfloat4.z, xmfloat4.w )
   {}
@@ -271,6 +275,11 @@ namespace SHADE
     return result;
   }
 
+  SHVec3 SHVec4::ToVec3() const noexcept
+  {
+    return SHVec3{ x, y, z };
+  }
+
   /*-----------------------------------------------------------------------------------*/
   /* Static Function Member Definitions                                                */
   /*-----------------------------------------------------------------------------------*/
